###############################################################################

module SC2Cli

###############################################################################

  module Subcommands

###############################################################################

    module HistoryShared

###############################################################################

      class HistoryMatches

###############################################################################

        @matches

###############################################################################

        def initialize(json:)
          @matches = Array.new

          if json.key?("matches") then
            matches = json["matches"]
            @@console.fatal("Returned history information matches is not an array!") unless matches.kind_of?(Array)

            matches.each do |match|
              match = HistoryMatch.new(json: match)
              add(match: match)
            end
          end
        end

###############################################################################

        def add(match:)
          @matches << match if match.kind_of?(HistoryMatch)
          @matches.sort_by!{ |match| match.date }.reverse!
        end

###############################################################################

        def to_s
          result = String.new

          @matches.each do |match|
            result += match.to_s
          end

          return result
        end

###############################################################################

      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
